local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local spellId, spellName, spellSchool, amount

local checkEvent = {
	SWING_DAMAGE = true
}

local readEvent = {
	SWING_DAMAGE = function(...) return 0, "Swing", "none", select(12, ...) end
}

local checkClass = {
	PRIEST = true,
	WARLOCK = true,
	MAGE = true
}

local playerList = {}
local playerColor = {}

local CasterMeleeDamage = {

	mName = "",
	mColor = {},
	mAmount = 0,
	mMisc = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(sourceName) and checkClass[select(2, UnitClass(sourceName))] then

			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = readEvent[eventType](...)

			if playerList[sourceName] ~= nil then

				playerList[sourceName].totalAmount = playerList[sourceName].totalAmount + amount

				if amount > playerList[sourceName].strongestPunsh then
					playerList[sourceName].strongestPunsh = amount
					playerList[sourceName].isCritical = ( critical == true )
				end

			else

				playerList[sourceName] = {}
				playerList[sourceName].totalAmount = amount
				playerList[sourceName].strongestPunsh = amount
				playerList[sourceName].isCritical = ( critical == true )

				playerColor[sourceName] = RAID_CLASS_COLORS[select(2,UnitClass(sourceName))]

			end

		end

	end,

	getTooltipText = function()
		return 'which cloth armored player did most melee damage'
	end,

	getLabelText = function()
		return 'Behavioural Disorder'
	end,

	getScoreInformation = function(self)

		for playerName, dataTable in pairs(playerList) do

			if type(dataTable) == "table" then

				if dataTable.totalAmount > self.mAmount then

					self.mAmount = dataTable.totalAmount
					self.mName = playerName
					self.mColor = playerColor[playerName]
					self.mMisc = "strongest punsh " .. dataTable.strongestPunsh

					if dataTable.isCritical then
						self.mMisc = self.mMisc .. " (critical!)"
					end

				end

			end

		end

		return self.mName, self.mColor, self.mAmount, self.mMisc
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mAmount = 0
		self.mMisc = " "
		playerList = {}
		playerColor = {}
	end

}

SchamzillasFightStats.ModuleController:registerModule(CasterMeleeDamage)