local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local environmentalType, amount

local checkEvent = {
	ENVIRONMENTAL_DAMAGE = true
}

local readEvent = {
	ENVIRONMENTAL_DAMAGE = function(...) return select(12, ...) end
}

local playerList = {}
local playerColor = {}

local EnvironmentalDamage = {

	mName = "",
	mColor = {},
	mAmount = 0,
	mMisc = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(destName) then

			environmentalType, amount = readEvent[eventType](...)

			if amount == nil then
				return
			end

			if playerList[destName] ~= nil then
				playerList[destName][environmentalType] = playerList[destName][environmentalType] + amount
			else
				playerList[destName] = {}
				playerList[destName][environmentalType] = amount
				playerColor[destName] = RAID_CLASS_COLORS[select(2,UnitClass(destName))]
			end

		end

	end,

	getTooltipText = function()
		return 'who took most environmental damage (falling, drowning, fire, etc.)'
	end,

	getLabelText = function()
		return 'Environmental Damage'
	end,

	getScoreInformation = function(self)

		for playerName, environmentalTypes in pairs(playerList) do

			for environmentalType, value in pairs(environmentalTypes) do

				if value > self.mAmount then
					self.mAmount = value
					self.mName = playerName
					self.mColor = playerColor[playerName]
					self.mMisc = environmentalType
				end

			end

		end

		return self.mName, self.mColor, self.mAmount, self.mMisc
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mAmount = 0
		self.mMisc = " "
		playerList = {}
		playerColor = {}
	end

}

SchamzillasFightStats.ModuleController:registerModule(EnvironmentalDamage)