local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local spellId, spellName, spellSchool, amount, overhealing, absorbed, critical

local checkEvent = {
	SPELL_HEAL = true,
	SPELL_PERIODIC_HEAL = true
}

local readEvent = {
	SPELL_HEAL = function(...) return select(12, ...) end,
	SPELL_PERIODIC_HEAL = function(...) return select(12, ...) end
}

local HighestOverheal = {

	mName = "",
	mColor = {},
	mOverheal = 0,
	mSpell = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(sourceName) and UnitIsPlayer(destName) then

			spellId, spellName, spellSchool, amount, overhealing, absorbed, critical = readEvent[eventType](...)

			if overhealing > self.mOverheal then
				self.mName = sourceName
				self.mColor = RAID_CLASS_COLORS[select(2,UnitClass(sourceName))]
				self.mOverheal = overhealing
				self.mSpell = spellName
			end

		end

	end,

	getTooltipText = function()
		return 'who overhealed the highest amount'
	end,

	getLabelText = function()
		return 'Heal Stuffer'
	end,

	getScoreInformation = function(self)
		return self.mName, self.mColor, self.mOverheal, self.mSpell
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mOverheal = 0
		self.mSpell = " "
	end

}

SchamzillasFightStats.ModuleController:registerModule(HighestOverheal)