local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local spellId, spellName, spellSchool, amount, overkill

local checkEvent = {
	SPELL_DAMAGE = true,
	SPELL_PERIODIC_DAMAGE = true,
	RANGE_DAMAGE = true,
	SWING_DAMAGE = true
}

local readEvent = {
	SPELL_DAMAGE = function(...) return select(12, ...) end,
	SPELL_PERIODIC_DAMAGE = function(...) return select(12, ...) end,
	RANGE_DAMAGE = function(...) return select(12, ...) end,
	SWING_DAMAGE = function(...) return 0, "Swing", "none", select(12, ...) end
}

local HighestOverkill = {

	mName = "",
	mColor = {},
	mOverkill = 0,
	mSpell = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(destName) then

			spellId, spellName, spellSchool, amount, overkill = readEvent[eventType](...)

			if overkill > self.mOverkill then
				self.mName = destName
				self.mColor = RAID_CLASS_COLORS[select(2,UnitClass(destName))]
				self.mOverkill = overkill
				self.mSpell = spellName
			end

		end

	end,

	getTooltipText = function()
		return 'who took the highest amount of overkill damage'
	end,

	getLabelText = function()
		return 'Fatality'
	end,

	getScoreInformation = function(self)
		return self.mName, self.mColor, self.mOverkill, self.mSpell
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mOverkill = 0
		self.mSpell = " "
	end

}

SchamzillasFightStats.ModuleController:registerModule(HighestOverkill)