local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local speed

local checkEvent = {
	SPELL_AURA_APPLIED = true
}

local readEvent = {
	SPELL_AURA_APPLIED = function(...) return select(12, ...) end
}

local playerList = {}

local HighestRunSpeed = {

	mName = "",
	mColor = {},
	mAmount = 0,
	mMisc = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(destName) then

			speed = GetUnitSpeed(destName)

			if playerList[destName] == nil then
				playerList[destName] = {}
				playerList[destName].color = RAID_CLASS_COLORS[select(2,UnitClass(destName))]
				playerList[destName].amount = speed
				playerList[destName].misc = 0
			end

			if speed > playerList[destName].amount then
				playerList[destName].amount = speed
			end

		end

	end,

	getTooltipText = function()
		return 'who temporary ran at highest speed'
	end,

	getLabelText = function()
		return 'The Flash'
	end,

	getScoreInformation = function(self)

		for playerName, playerTable in pairs(playerList) do

			if playerTable.amount > self.mAmount then
				self.mName = playerName
				self.mColor = playerTable.color
				self.mAmount = playerTable.amount * 100 / 7
				self.mMisc = "%%"
			end

		end

		return self.mName, self.mColor, self.mAmount, self.mMisc
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mAmount = 0
		self.mMisc = " "
		playerList = {}
	end

}

--SchamzillasFightStats.ModuleController:registerModule(HighestRunSpeed)