local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical

local checkEvent = {
	SPELL_DAMAGE = true,
	SPELL_PERIODIC_DAMAGE = true,
	RANGE_DAMAGE = true,
	SWING_DAMAGE = true
}

local readEvent = {
	SPELL_DAMAGE = function(...) return select(12, ...) end,
	SPELL_PERIODIC_DAMAGE = function(...) return select(12, ...) end,
	RANGE_DAMAGE = function(...) return select(12, ...) end,
	SWING_DAMAGE = function(...) return 0, "Swing", none, select(12, ...) end
}

local LowestCrit = {

	mName = "",
	mColor = {},
	mAmount = 0,
	mSpell = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(sourceName) then

			spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = readEvent[eventType](...)

			if critical == true then

				if self.mAmount == 0 or amount < self.mAmount then
					self.mName = sourceName
					self.mColor = RAID_CLASS_COLORS[select(2,UnitClass(sourceName))]
					self.mAmount = amount
					self.mSpell = spellName
				end

			end

		end

	end,

	getTooltipText = function()
		return 'who did the smallest critical hit'
	end,

	getLabelText = function()
		return 'Tiniest Critical'
	end,

	getScoreInformation = function(self)
		return self.mName, self.mColor, self.mAmount, self.mSpell
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mAmount = 0
		self.mSpell = " "
	end

}

SchamzillasFightStats.ModuleController:registerModule(LowestCrit)