local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local spellId, spellName, spellSchool, amount, overhealing, absorbed, critical

local checkEvent = {
	SPELL_HEAL = true,
	SPELL_PERIODIC_HEAL = true
}

local readEvent = {
	SPELL_HEAL = function(...) return select(12, ...) end,
	SPELL_PERIODIC_HEAL = function(...) return select(12, ...) end
}

local checkSpec = {
	[22842] = false,	-- rasende regeneration

	[774] = false,		-- rejuvenation
	[8936] = false,		-- regrowth
	[33763] = false,	-- bluehendes leben
	[48438] = false,	-- wild growth
	[81269] = false,	-- efflorescence

	[49998] = false,	-- todessto

	[183811] = false, 	-- judgment-of-light
	[209540] = false, 	-- light-of-the-titans
	[213652] = false, 	-- hand-of-the-protector

	[19750] = false,	-- flash-of-light
	[25914] = false,	-- holy-shock
	[53652] = false,	-- beacon-of-light
	[183811] = false,	-- judgment-of-light
	[225311] = false,	-- light-of-dawn

	[1064] = false,		-- chain-heal
	[75367] = false,	-- springflut
	[77472] = false, 	-- welle der heilung

	[139] = false,		-- renew
	[596] = false,		-- prayer-of-healing
	[33110] = false,	-- prayer-of-mending
	[34861] = false,	-- holy-word-sanctify
	[77489] = false,	-- echo-of-light

	[81751] = false,	-- atonement
	[194509] = false,	-- power-word-radiance
	[208771] = false,	-- smite

	[115175] = false,	-- soothing-mist
	[115310] = false,	-- revival
	[116849] = false,	-- life-cocoon
	[119611] = false,	-- renewing-mist
	[124682] = false,	-- enveloping-mist
	[198664] = false,	-- invoke-chi-ji-the-red-crane

	[190456] = false,	-- zaehne zusammenbeissen

	[122281] = false,	-- heilendes-elixier
	[208840] = false,	-- gai-plins-kaiserliches-gebrau
	[216521] = false,	-- himmlisches-gluck

	[228477] = false	-- seelenspalter
}

local playerList = {}

local MostDdHeal = {

	mName = "",
	mColor = {},
	mAmount = 0,
	mMisc = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(sourceName) then

			if playerList[sourceName] == nil then
				playerList[sourceName] = {}
				playerList[sourceName].color = RAID_CLASS_COLORS[select(2,UnitClass(sourceName))]
				playerList[sourceName].amount = 0
				playerList[sourceName].misc = 0
				playerList[sourceName].isDd = true
			end

			if playerList[sourceName].isDd then

				spellId, spellName, spellSchool, amount, overhealing, absorbed, critical = readEvent[eventType](...)

				if checkSpec[spellId] == false then
					playerList[sourceName].isDd = false
				else
					playerList[sourceName].amount = playerList[sourceName].amount + ( amount - overhealing )
					playerList[sourceName].misc = playerList[sourceName].misc + overhealing
				end

			end

		end

	end,

	getTooltipText = function()
		return 'which damage dealer did the most effective healing (no overheal)'
	end,

	getLabelText = function()
		return 'Who Is The Doctor'
	end,

	getScoreInformation = function(self)

		for playerName, playerTable in pairs(playerList) do

			if playerTable.amount > self.mAmount then
				self.mName = playerName
				self.mColor = playerTable.color
				self.mAmount = playerTable.amount
				self.mMisc = playerTable.misc .. "(Overheal)"
			end

		end

		return self.mName, self.mColor, self.mAmount, self.mMisc
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mAmount = 0
		self.mMisc = " "
		playerList = {}
	end

}

SchamzillasFightStats.ModuleController:registerModule(MostDdHeal)