local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local spellId, spellName, spellSchool

local checkEvent = {
	SPELL_SUMMON = true
}

local readEvent = {
	SPELL_SUMMON = function(...) return select(12, ...) end
}

local playerList = {}
local playerColor = {}
local playerMinions = {}

local MostSummons = {

	mName = "",
	mColor = {},
	mAmount = 0,
	mMisc = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(sourceName) then

			spellId, spellName, spellSchool = readEvent[eventType](...)

			if playerList[sourceName] ~= nil then

				playerList[sourceName] = playerList[sourceName] + 1

				if playerMinions[sourceName][spellName] ~= nil then
					playerMinions[sourceName][spellName] = playerMinions[sourceName][spellName] + 1
				else
					playerMinions[sourceName][spellName] = 1
				end

			else
				playerList[sourceName] = 1
				playerColor[sourceName] = RAID_CLASS_COLORS[select(2,UnitClass(sourceName))]
				playerMinions[sourceName] = {}
				playerMinions[sourceName][spellName] = 1
			end

		end

	end,

	getTooltipText = function()
		return 'who summoned most minions'
	end,

	getLabelText = function()
		return 'Like A Rabbit'
	end,

	getScoreInformation = function(self)

		for playerName, value in pairs(playerList) do

			if value > self.mAmount then
				self.mAmount = value
				self.mName = playerName
				self.mColor = playerColor[playerName]
			end

		end

		if type(playerMinions[self.mName]) == "table" then

			for minionName, value in pairs(playerMinions[self.mName]) do
				self.mMisc = self.mMisc .. value .. "x " .. minionName .. "  "
			end

		end

		return self.mName, self.mColor, self.mAmount, self.mMisc
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mAmount = 0
		self.mMisc = " "
		playerList = {}
		playerColor = {}
	end

}

SchamzillasFightStats.ModuleController:registerModule(MostSummons)