local SchamzillasFightStats = _G.SchamzillasFightStats

local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName

local spellId, spellName, spellSchool, extraSpellID, extraSpellName, extraSchool

local checkEvent = {
	SPELL_INTERRUPT = true,
	SPELL_CAST_SUCCESS = true
}

local readEvent = {
	SPELL_INTERRUPT = function(...)
		spellId, spellName, spellSchool, extraSpellID, extraSpellName, extraSchool = select(12, ...)
		return spellId, spellName, -1
	end,
	SPELL_CAST_SUCCESS = function(...)
		spellId, spellName, spellSchool = select(12, ...)
		return spellId, spellName, 1
	end
}

local InterruptIdTable = {
	[1766] = true,		-- kick
	[2139] = true, 		-- counterspell
	[6552] = true,		-- Zuschlagen
	[19647] = true,		-- spell-lock (pet)
	[47528] = true,		-- mind-freeze
	[57994] = true,		-- wind-shear
	[78675] = true,		-- solar-beam
	[96231] = true,		-- zurechtweisung
	[106839] = true,	-- skull-bash
	[147362] = true,	-- gegenschuss
	[183752] = true,	-- Magie aufzehren
	[231665] = true		-- schild des rachers
}

local playerList = {}
local playerColor = {}

local UselessInterrupt = {

	mName = "",
	mColor = {},
	mAmount = 0,
	mMisc = "",

	analyze = function(self, ...)

		timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...

		if checkEvent[eventType] ~= nil and UnitIsPlayer(sourceName) then

			spellId, spellName, delta = readEvent[eventType](...)

			if InterruptIdTable[spellId] then

				if playerList[sourceName] ~= nil then
					playerList[sourceName] = playerList[sourceName] + delta
				else
					playerList[sourceName] = delta
					playerColor[sourceName] = RAID_CLASS_COLORS[select(2,UnitClass(sourceName))]
				end

			end

		end

	end,

	getTooltipText = function()
		return 'who used most interrupts without interrupting'
	end,

	getLabelText = function()
		return 'Kick All The Things!'
	end,

	getScoreInformation = function(self)

		for playerName, value in pairs(playerList) do

			if value > self.mAmount then
				self.mAmount = value
				self.mName = playerName
				self.mColor = playerColor[playerName]
			end

		end

		return self.mName, self.mColor, self.mAmount, self.mMisc
	end,

	init = function(self)
		self.mName = "-"
		self.mColor = {r = 1.0, g = 1.0, b = 1.0, a = 1.0}
		self.mAmount = 0
		self.mMisc = " "
		playerList = {}
		playerColor = {}
	end

}

SchamzillasFightStats.ModuleController:registerModule(UselessInterrupt)